#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<cstdint>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<stack>
#include<queue>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<vector>
#include<string>
#include<random>
#include<stdio.h>
#include<numeric>
#include<bitset>
#include<cstring>

using namespace std;

#define ll long long
#define ld long double
#define all(x) begin(x), end(x)
#define int long long
// g++ -D_GLIBCXX_DEBUG -o main main.cpp

/*#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avhull[i].x,fma")*/
// #pragma GCC optimize("O3")

const long long MAXN = 1e3 + 500;
const long double PI = acosl(-1);
const int inf = 2e9;
const long long INF = 1e17;
const long long SZ = (1 << 19);
const int SIZE = 1e7 + 5;
const long long MOD = 1e9 + 7; // 998244353;
const long double eps = 1e-6;

std::random_device rd;
std::mt19937 ran(rd());

int getBit(int num, int nbit) {
    int mask = (1 << nbit);
    return (num & mask) ? 1 : 0;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto& i : arr) out << i << ' ';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (auto& i : arr) in >> i;
    return in;
}

int a[MAXN][MAXN], was[MAXN][MAXN], dir, n, m;

void go(int& x, int& y) {
    if (dir == 1) {
        if (x == 0 && y == 0) {
            dir = 7; go(x, y);
        }
        else if (x == 0) {
            dir = 4; go(x, y);
        }
        else if (y == 0) {
            dir = 5; go(x, y);
        }
        else {
            x--; y--;
        }
    }
    else if (dir == 2) {
        if (x == 0) {
            dir = 6; go(x, y);
        }
        else {
            x--;
        }
    }
    else if (dir == 3) {
        if (x == 0 && y == m - 1) {
            dir = 4; go(x, y);
        }
        else if (x == 0) {
            dir = 7; go(x, y);
        }
        else if (y == m - 1) {
            dir = 2; go(x, y);
        }
        else {
            x--; y++;
        }
    }
    else if (dir == 4) {
        if (y == 0) {
            dir = 8; go(x, y);
        }
        else {
            y--;
        }
    }
    else if (dir == 5) {
        if (y == m - 1) {
            dir = 1; go(x, y);
        }
        else {
            y++;
        }
    }
    else if (dir == 6) {
        if (x == n - 1 && y == 0) {
            dir = 5; go(x, y);
        }
        else if (x == n - 1) {
            dir = 2; go(x, y);
        }
        else if (y == 0) {
            dir = 7; go(x, y);
        }
        else {
            x++; y--;
        }
    }
    else if (dir == 7) {
        if (x == n - 1) {
            dir = 3; go(x, y);
        }
        else {
            x++;
        }
    }
    else if (dir == 8) {
        if (x == n - 1 && y == m - 1) {
            dir = 2; go(x, y);
        }
        else if (x == n - 1) {
            dir = 5; go(x, y);
        }
        else if (y == m - 1) {
            dir = 4; go(x, y);
        }
        else {
            x++; y++;
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int x, y; cin >> x >> y;
    x--; y--;
    int k; cin >> dir >> k;
    int ans = 0;
    while (was[x][y] == 0) {
        was[x][y] = 1;
        ans += a[x][y];
        for (int i = 0; i < k; ++i)
            go(x, y);
    }
    cout << ans << '\n';
    return;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cout << fixed << setprecision(5);
#else
    ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(16);
#endif
    srand(time(NULL));
    //freopen("in.in", "r", stdin);
    //freopen("out.out", "w", stdout);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}