#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define FastIO() {ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);}
#define eol '\n'
#define ll long long

vector <vector<char>> Map;
bool check(int i1, int j1, bool more, char op1, char op2) {
    if (more) {
        int i, j;
        i = i1 + 1; j = j1 + 1;
        while (i < 8 && i >= 0 && j < 8 && j >= 0) {
            if (Map[i][j] == op1 || Map[i][j] == op2) {
                return true;
            }
            i++; j++;
        }

        i = i1 - 1; j = j1 + 1;
        while (i < 8 && i >= 0 && j < 8 && j >= 0) {
            if (Map[i][j] == op1 || Map[i][j] == op2) {
                return true;
            }
            i--; j++;
        }

        i = i1 + 1; j = j1 - 1;
        while (i < 8 && i >= 0 && j < 8 && j >= 0) {
            if (Map[i][j] == op1 || Map[i][j] == op2) {
                return true;
            }
            i++; j--;
        }

        i = i1 - 1; j = j1 - 1;
        while (i < 8 && i >= 0 && j < 8 && j >= 0) {
            if (Map[i][j] == op1 || Map[i][j] == op2) {
                return true;
            }
            i--; j--;
        }

    } else {
        if (i1+1 < 8 && j1+1 < 8 && (Map[i1+1][j1+1] == op1 || Map[i1+1][j1+1] == op2)) {
            return true;
        }
        if (i1-1 >= 0 && j1+1 < 8 && (Map[i1-1][j1+1] == op1 || Map[i1-1][j1+1] == op2)) {
            return true;
        }
        if (i1+1 < 8 && j1-1 >= 0 && (Map[i1+1][j1-1] == op1 || Map[i1+1][j1-1] == op2)) {
            return true;
        }
        if (i1-1 >= 0 && j1-1 >= 0 && (Map[i1-1][j1-1] == op1 || Map[i1-1][j1-1] == op2)) {
            return true;
        }
    }
    return false;
}

int main() {
    char W; cin >> W;
    Map.resize(8, vector<char>(8));
    for (int i = 0; i < 8; i++) {
        for (int j = 0; j < 8; j++) {
            cin >> Map[i][j];   
        }
    }
    bool find = false;
    if (W == 'b') {
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                if (Map[i][j] == 'b') {
                    find = check(i, j, false, 'w', 'W');
                }
                if (Map[i][j] == 'B') {
                    find = check(i, j, true, 'w', 'W');
                }
                if (find) {
                    cout << i + 1 << " " << j + 1 << eol;
                    break;
                }
            }
            if (find) break;
        }
    } else {
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                if (Map[i][j] == 'w') {
                    find = check(i, j, false, 'b', 'B');
                }
                if (Map[i][j] == 'W') {
                    find = check(i, j, true, 'b', 'B');
                }
                if (find) {
                    cout << i + 1 << " " << j + 1 << eol;
                    break;
                }
            }
            if (find) break;
        }
    }
    if (!find) {
        cout << 0 << eol;
    }
    return 0;
}