#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define FastIO() {ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);}
#define eol '\n'
#define ll long long

ll n, m; 
vector <vector <int>> Map;
int iCur, jCur; 
int dir, step;
int ans = 0;
int curStep = 1;

void point(int i, int j) {
    if (curStep == step) {
        ans += Map[i][j];
        Map[i][j] = 0;
        curStep = 1;
    } else {
        curStep++;
    }
}

bool Can(int i, int j) {
    if (i >= 0 && j >= 0 && i < n && j < m) {
        return true;
    }
    return false;
}

void ToDir(int curDir) {
    if (curDir == 1) {
        iCur -= 1; jCur -= 1;
    } 
    if (curDir == 2) {
        iCur -= 1;
    }
    if (curDir == 3) {
        iCur -= 1; jCur += 1;
    }
    if (curDir == 4) {
        jCur -= 1;
    } 
    if (curDir == 5) {
        jCur += 1;
    }
    if (curDir == 6) {
        iCur += 1; jCur -= 1;
    }
    if (curDir == 7) {
        iCur += 1;
    } 
    if (curDir == 8) {
        iCur += 1; jCur += 1;
    }
}

int main() {
    FastIO();
    cin >> n >> m;
    Map.resize(n, vector <int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> Map[i][j];
        }
    }
    cin >> iCur >> jCur; iCur--; jCur--;
    cin >> dir >> step;
    ans += Map[iCur][jCur];
    Map[iCur][jCur] = 0;
    for (int i = 0; i <= n*m; i++) {
        if (dir == 2) {
            if (!Can(iCur - 1, jCur)) {
                dir = 7;  
            } 
            ToDir(dir);
            point(iCur, jCur);
        } else if (dir == 7) {
            if (!Can(iCur + 1, jCur)) {
                dir = 2; 
            } 
            ToDir(dir);
            point(iCur, jCur);
        } else if (dir == 4) {
            if (!Can(iCur, jCur - 1)) {
                dir = 5;
            }
            ToDir(dir);
            point(iCur, jCur);
        } else if (dir == 5) {
            if (!Can(iCur, jCur + 1)) {
                dir = 4; 
            } 
            ToDir(dir);
            point(iCur, jCur);
        } 
        else if (dir == 1) {
            if (Can(iCur - 1, jCur - 1)) {
                ToDir(dir);
                point(iCur, jCur);
            } else { // Не может 
                if (Can(iCur + 1, jCur - 1)) { // вверх
                    dir = 6;
                    ToDir(dir);
                    point(iCur, jCur);
                } else if (Can(iCur - 1, jCur + 1)) { // вбок
                    dir = 3;
                    ToDir(dir);
                    point(iCur, jCur);
                } else {
                    dir = 8;
                    ToDir(dir);
                    point(iCur, jCur);
                }
            }
        } 
        else if (dir == 8) {
            if (Can(iCur + 1, jCur + 1)) {
                ToDir(dir);
                point(iCur, jCur);
            } else { // Не может 
                if (Can(iCur - 1, jCur + 1)) { // вверх
                    dir = 3;
                    ToDir(dir);
                    point(iCur, jCur);
                } else if (Can(iCur + 1, jCur - 1)) { // вбок
                    dir = 6;
                    ToDir(dir);
                    point(iCur, jCur);
                } else {
                    dir = 1;
                    ToDir(dir);
                    point(iCur, jCur);
                }
            }
        } 
        else if (dir == 3) {
            if (Can(iCur - 1, jCur + 1)) {
                ToDir(dir);
                point(iCur, jCur);
            } else { // Не может 
                if (Can(iCur + 1, jCur + 1)) { // вверх
                    dir = 8;
                    ToDir(dir);
                    point(iCur, jCur);
                } else if (Can(iCur - 1, jCur - 1)) { // вбок
                    dir = 1;
                    ToDir(dir);
                    point(iCur, jCur);
                } else {
                    dir = 6;
                    ToDir(dir);
                    point(iCur, jCur);
                }
            }
        } 
        else if (dir == 6) {
            if (Can(iCur + 1, jCur - 1)) {
                ToDir(dir);
                point(iCur, jCur);
            } else { // Не может 
                if (Can(iCur - 1, jCur - 1)) { // вверх
                    dir = 1;
                    ToDir(dir);
                    point(iCur, jCur);
                } else if (Can(iCur + 1, jCur + 1)) { // вбок
                    dir = 8;
                    ToDir(dir);
                    point(iCur, jCur);
                } else {
                    dir = 3;
                    ToDir(dir);
                    point(iCur, jCur);
                }
            }
        } 
    }
    cout << ans << eol;
    return 0;
}