directions = [None, (-1, -1), (-1, 0), (-1, 1), (0, -1), (0, 1), (1, -1), (1, 0), (1, 1)]
angles = [1, 2, 3, 5, 8, 7, 6, 4]

def get_new_dirction(current, normal):
    k = -2 * (current[0]*normal[0] + current[1]*normal[1])
    return (round(normal[0]*k + current[0]), round(normal[1]*k + current[1]))

N, M = map(int, input().split())

mat = []

for i in range(N):
    mat.append(list(map(int, input().split())))

pos = list(map(lambda x: int(x)-1, input().split()))
dirction_ind = int(input())
vel = directions[dirction_ind]

score = 0

collision = False

while mat[pos[0]][pos[1]] != 'x' or collision:
    if not collision:
        score += mat[pos[0]][pos[1]]
    mat[pos[0]][pos[1]]= 'x'
    pos[0] += vel[0]
    pos[1] += vel[1]
    if pos[0] in [-1, N] or pos[1] in [-1, M]:
        normal = (1 if pos[0] == -1 else (-1 if pos[0]==N else 0), 1 if pos[1] == -1 else  (-1 if pos[1]==M else 0))
        pos[0] -= vel[0]
        pos[1] -= vel[1]
        len_normal = (normal[0]**2 + normal[1]**2)**0.5
        normal = (normal[0]/len_normal, normal[1]/len_normal)
        refl_dir = get_new_dirction(vel, normal)
        #print(normal, vel)
        ang = angles.index(directions.index(refl_dir))
        ang = (ang+1)%8
        vel = directions[angles[ang]]
        collision = True
    else:
        collision = False
    #print(pos, collision)
    #for i in range(N):
    #    print(*mat[i])
    #print()

print(score)
