//#include <bits\stdc++.h>

#include <iostream>
#include <vector>
#include <cmath>
#include <stdint.h>
#include <set>

#define int long long
#define all(c) c.begin(), c.end()

using namespace std;

using ll = int64_t;
using ull = uint64_t;
//usinng ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;

const int INF = (int)1e9 + (int)1e3;
const int INFL = (int)1e18 + (int)1e6;
const int pi = atan2(0, -1);
const int M = (int)1e9 + 7;

struct elem {
    int t, m, p, f;
};

void solve() {
    int x, y;
    cin >> x >> y;

    vector<vector<int>> a(4, vector<int>(5));
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 5; ++j) {
            cin >> a[i][j];
        }
    }

    vector<elem> profit(100, { -y, -y, -y, -y });
    for (int i = 0; i < 100; ++i) {
        if ((i + 1) % 10 == 0) {
            profit[i].f += x;
            profit[i].t += x;
            profit[i].m += x;
            profit[i].p += x;
        }
    }

    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 5; ++j) {
            int el = a[i][j];
            if (el == 0) continue;
            --el;
            if (i == 0) {
                profit[el].t -= 5;
                profit[el].m -= 5;
                profit[el].p -= 5;
                for (int k = el + 6 + 2 - 1; k < 100; k += 2) {
                    profit[k].t += 2;
                    profit[k].p += 1;
                }
                for (int k = el + 6 + 5 - 1; k < 100; k += 5) {
                    profit[k].t -= 1;
                }
            } else if (i == 1) {
                profit[el].t -= 5;
                profit[el].p -= 10;
                for (int k = el + 4 + 6 - 1; k < 100; k += 6) {
                    profit[k].f += 8;
                }
                for (int k = el + 4 + 10 - 1; k < 100; k += 10) {
                    profit[k].p -= 2;
                }
            } else if (i == 2) {
                profit[el].t -= 10;
                profit[el].m -= 5;
                profit[el].p -= 10;
                for (int k = el + 10 + 10 - 1; k < 100; k += 10) {
                    profit[k].m += 6;
                }
                for (int k = el + 10 + 20 - 1; k < 100; k += 20) {
                    profit[k].t -= 2;
                }
            } else {
                profit[el].t -= 10;
                profit[el].m -= 5;
                profit[el].p -= 8;
                for (int k = el + 8 + 7 - 1; k < 100; k += 7) {
                    profit[k].p += 7;
                }
                for (int k = el + 8 + 12 - 1; k < 100; k += 12) {
                    profit[k].t -= 1;
                    profit[k].m -= 1;
                }
            }
        }
    }

    int ans = 100;
    elem cur = { 40, 40, 40, 40 };
    for (int i = 0; i < 100; ++i) {
        cur.f += profit[i].f;
        cur.m += profit[i].m;
        cur.p += profit[i].p;
        cur.t += profit[i].t;

        if (cur.f <= 0 || cur.m <= 0 || cur.p <= 0 || cur.t <= 0) {
            ans = i + 1;
            break;
        }
    }

    cout << ans << "\n";
    cout << cur.t << "\n";
    cout << cur.m << "\n";
    cout << cur.p << "\n";
    cout << cur.f << "\n";
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}
