//#include <bits\stdc++.h>

#include <iostream>
#include <vector>
#include <cmath>
#include <stdint.h>
#include <set>

#define int long long
#define all(c) c.begin(), c.end()

using namespace std;

using ll = int64_t;
using ull = uint64_t;
//usinng ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;

const int INF = (int)1e9 + (int)1e3;
const int INFL = (int)1e18 + (int)1e6;
const int pi = atan2(0, -1);
const int M = (int)1e9 + 7;

struct box_elem {
    int x1, y1, x2, y2;
    double c;
};

void solve() {
    int dirx, diry;
    int dir;
    cin >> dir;

    if (dir < 180)
        diry = 1;
    else
        diry = -1;

    if (dir < 90 || dir > 270)
        dirx = 1;
    else
        dirx = -1;

    double in;
    cin >> in;

    int n;
    cin >> n;

    vector<vector<int>> a(210, vector<int>(210, -1));
    vector<box_elem> box(n);
    for (int i = 0; i < n; ++i) {
        cin >> box[i].x1 >> box[i].y1 >> box[i].x2 >> box[i].y2;
        cin >> box[i].c;
        box[i].c /= 100;

        for (int j = box[i].x1; j <= box[i].x2; ++j) {
            a[j + 101][box[i].y1 + 101] = i;
            a[j + 101][box[i].y2 + 101] = i;
        }

        for (int j = box[i].y1; j >= box[i].y2; --j) {
            a[box[i].x1 + 101][j + 101] = i;
            a[box[i].x2 + 101][j + 101] = i;
        }
    }

    double s = in;
    int fi, fj;
    cin >> fi >> fj;
    int ci = 0, cj = 0;
    while (!(ci == fi && cj == fj)) {
        ci += dirx;
        cj += diry;

        if (a[ci + 101][cj + 101] != -1) {
            box_elem curb = box[a[ci + 101][cj + 101]];
            if ((ci == curb.x1 || ci == curb.x2) && (cj == curb.y1 || cj == curb.y2)) {
                dirx = -dirx;
                diry = -diry;
            } else if (a[ci + 101 - 1][cj + 101] != -1 && a[ci + 101 + 1][cj + 101] != -1) {
                diry = - diry;
            } else {
                dirx = -dirx;
            }

            in *= (1 - curb.c);
            if (in < 0.1 * s) {
                cout << curb.x1 << " " << curb.y1 << " " << curb.x2 << " " << curb.y2 << " ";
                cout << (int)in << "\n";
                return;
            }
        }
    }

    cout << (int)in << "\n";
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}
