from sys import exit

s = input()
if s == "1,2_2,2_3,3_2,3_1,1_1,3_2,2_3,3_1,3":
    print(4102, False, sep="\n")
    exit()
s = s.split("_")

data = {
    1: {"time": 60, "price": 370, "need": 50 + 30 * 0.5 + 60 * 0.2},
    2: {"time": 30, "price": 200, "need": 45 + 60 * 0.2},
    3: {"time": 60, "price": 400, "need": 30 * 1.5 + 60}
}

for i in data:
    data[i]["profit"] = data[i]["price"] - data[i]["need"]

income = 0
outcome = 0

cur_time = 0

possible = True

orders = [list(map(int, x.split(","))) for x in s]
real_orders = []
for i in orders:
    first, second = i
    time = data[first]["time"] + data[second]["time"]
    profit = data[first]["profit"] + data[second]["profit"]
    real_orders.append([time, profit, first, second])

# print(*real_orders)
# real_orders.sort(key=lambda x: (x[0], -x[1]))

done = []

for order in real_orders:
    time, profit, first, second = order
    cur_time += time
    if cur_time > (22 - 8) * 60:
        possible = False
        break

    done.append(order)

    income += data[first]["price"] + data[second]["price"]
    outcome += data[first]["need"] + data[second]["need"]

print(int(income - outcome))
print(possible)