from itertools import permutations
from sys import exit

n = int(input())


blocks = []
for i in range(n):
    blocks.append("")
    for _ in range(3):
        blocks[-1] += "".join(input().split())

if n == 1:
    print(1)
    exit()
if n == 2:
    print(1, 2)
    exit()
g = {}

for k in range(8):
    x = bin(k)[2:]
    x = (3 - len(x)) * "0" + x
    g[x] = []


first = -1
last = -1
for i in range(n):
    block = blocks[i]
    g[block[6:]].append(i)
    g[block[:3][::-1]].append(i)

for k in range(8):
    x = bin(k)[2:]
    x = (3 - len(x)) * "0" + x
    g[x] = list(set(g[x]))

first, last = g["111"]

lst = list(range(n))
lst.remove(first)
lst.remove(last)

if blocks[first][6:] == "111":
    first_up = blocks[first][:3]
else:
    first_up = blocks[first][6:][::-1]

if blocks[last][:3] == "111":
    last_down = blocks[last][6:]
else:
    last_down = blocks[last][:3][::-1]

def match(up, down):
    for i in range(3):
        if up[i] == down[i]: return False

    return True


for k in permutations(lst):
    prev_up = first_up
    good = True
    for i in k:
        if not good: break
        cur_up, cur_down = blocks[i][:3], blocks[i][6:]
        if match(prev_up, cur_down):
            prev_up = cur_up
            continue
        else:
            cur_up, cur_down = cur_down[::-1], cur_up[::-1]
            if match(prev_up, cur_down):
                prev_up = cur_up
            else:
                good = False
    
    if good and match(prev_up, last_down):
        print(first + 1, end=" ")
        for i in k:
            print(i + 1, end=" ")
        print(last + 1)
        break