#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    int x, y;
    cin >> x >> y;
    --x, --y;

    int key;
    cin >> key;

    if (key == 2 || key == 7) {
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans += a[i][y];
        }

        cout << ans;
        return;
    }

    if (key == 4 || key == 5) {
        int ans = 0;
        for (int i = 0; i < m; ++i) {
            ans += a[x][i];
        }

        cout << ans;
        return;
    }

    vector<vector<set<int>>> s(n, vector<set<int>>(m));

    int ans = 0;
    while (true) {
        if (s[x][y].count(key)) {
            break;
        }

        ans += a[x][y];
        a[x][y] = 0;
        s[x][y].insert(key);

        if (key == 1) {
            if (x == 0 && y == 0) {
                key = 8;
                ++x, ++y;

                continue;
            }

            if (x == 0) {
                key = 6;
                ++x, --y;

                continue;
            }

            if (y == 0) {
                key = 3;
                --x, ++y;

                continue;
            }

            --x, --y;
            continue;
        }

        if (key == 3) {
            if (x == 0 && y == m - 1) {
                key = 6;
                ++x, --y;

                continue;
            }

            if (x == 0) {
                key = 8;
                ++x, ++y;

                continue;
            }

            if (y == m - 1) {
                key = 1;
                --x, --y;

                continue;
            }

            --x, ++y;
            continue;
        }

        if (key == 6) {
            if (x == n - 1 && y == 0) {
                key = 3;
                --x, ++y;

                continue;
            }

            if (x == n - 1) {
                key = 1;
                --x, --y;

                continue;
            }

            if (y == 0) {
                key = 8;
                ++x, ++y;

                continue;
            }

            ++x, --y;
        }

        if (key == 8) {
            if (x == n - 1 && y == m - 1) {
                key = 1;
                --x, --y;

                continue;
            }

            if (x == n - 1) {
                key = 3;
                --x, ++y;

                continue;
            }

            if (y == m - 1) {
                key = 6;
                ++x, --y;

                continue;
            }

            ++x, ++y;
            continue;
        }
    }

    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}
