#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define size(a) (int)a.size()
#define int long long

using namespace std;
using ll = long long;
using ld = long double;
using pi = complex<int>;

template<typename T = int> T scn() {T x; cin >> x; return x; }
template<typename T> bool ckmin(T &a, const T &b) {return b < a && (a = b, true); }
template<typename T> bool ckmax(T &a, const T &b) {return b > a && (a = b, true); }
template<typename T> bool ckpass(T &a, const T &b, bool con) {return con && (a = b, true); }
template<typename T> bool ckpass(T &a, const T &b, const T &c, bool con) {return con ? (a = b, true) : (a = c, false); }

map<int, pi> delta = {
        {0, {1, 0}},
        {45, {1, 1}},
        {90, {0, 1}},
        {135, {-1,  1}},
        {180, {-1, 0}},
        {225, {-1, -1}},
        {270, {0, -1}},
        {315, {1, -1}},
};

bool are_in(int d, int l, int r) {
    return l <= d && d <= r;
}

struct rect {
    pi p1, p2;
    ld t;
    rect(int x1, int y1, int x2, int y2, ld _t) {
        p1 = {x1, y1};
        p2 = {x2, y2};
        t = _t;
    }

    bool collide(pi d) const {
        return are_in(d.real(), p1.real(), p2.real()) && are_in(d.imag(), p2.imag(), p1.imag());
    }
};

void solution() {
    int dir = scn();
    ld c = scn<ld>();
    pi cur = {0, 0};
    vector<rect> rs;
    int n = scn();
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2; ld t;
        cin >> x1 >> y1 >> x2 >> y2 >> t;
        rs.emplace_back(x1, y1, x2, y2, t);
    }
    pi fn = {scn(), scn()};
    ld crit = c * 0.1;
    while (cur != fn) {
        for (auto &r : rs) {
            if (r.collide(cur)) {
                if (dir == 0) {
                    dir = 180;
                } else if (dir == 180) {
                    dir = 0;
                } else if (dir == 90) {
                    dir = 270;
                } else if (dir == 270) {
                    dir = 90;
                } else if (dir == 45) {
                    if (cur.imag() == r.p2.imag()) {
                        dir = 315;
                    } else if (cur.real() == r.p1.real()) {
                        dir = 135;
                    }
                } else if (dir == 135) {
                    if (cur.imag() == r.p2.imag()) {
                        dir = 225;
                    } else if (cur.real() == r.p2.real()) {
                        dir = 45;
                    }
                } else if (dir == 225) {
                    if (cur.imag() == r.p1.imag()) {
                        dir = 135;
                    } else if (cur.real() == r.p2.real()) {
                        dir = 315;
                    }
                } else if (dir == 315) {
                    if (cur.imag() == r.p1.imag()) {
                        dir = 45;
                    } else if (cur.real() == r.p1.real()) {
                        dir = 225;
                    }
                }
                c = c * (100.0 - r.t) / 100.0;
                if (c < crit) {
                    cout << r.p1.real() << ' ' << r.p1.imag() << ' ' << r.p2.real() << ' ' << r.p2.imag() << ' ' <<  (int)c << '\n';
                    return;
                }
                break;
            }
        }
        cur += delta[dir];
    }
    cout << (int)c << '\n';
}

signed main() {
    #ifdef ONPC
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
    #endif
    solution();
}

