def check1(lbl, nbl):
    res = [False] * 3
    
    for i in range(3):
        res[i] = lbl[0][i] != nbl[1][i] and lbl[1][i] != nbl[2][i]
    return sum(res) == 3

def check2(lbl, nbl):
    res = [False]*3

    for i in range(3):
        res[i] = lbl[0][i] != nbl[2][i] and lbl[1][i] == 1
    return sum(res) == 3

def main():
    blocks = []
    first = -1
    for i in range(int(input())):
        blocks.append([list(map(int, input().split())) for j in range(3)])
        if blocks[i][2] == [1, 1, 1]: first = blocks[i]

    tower = [first]
    last = first

    while len(tower) != len(blocks):
        for block in blocks:
            if check1(last, block) or check2(last, block):
                tower.append(block)
                last = block
    tow_out = []
    for block in tower:
        tow_out.append(blocks.index(block)+1)
    
    return tow_out
    

if __name__ == "__main__":
    res = main()
    print(*res)
