﻿#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<algorithm>

#define ll long long
#define ii pair<ll, ll>
#define V vector
#define F first
#define S second
#define P pair
#define pb push_back
#define for_(i, n) for(int i = 0; i < n; i++)
#define for_in(i, l, r) for(int i = l; i < r; i++)
#define for_r(i, n) for(int i = n - 1; i >= 0; i--)
#define has(s, x) (s.find(x) != s.end())

using namespace std;

const ll inf = 1ll << 60;

void eco() {
	ll s, r, d;
	cin >> s >> r >> d;

	for_(i, 50) {
		s += s * r / 100;
		for_(j, 12) {
			s -= d;

			if (s <= 0) {
				cout << "True\n" << i * 12 + j;
				return;
			}
		}
	}
	cout << "False\n0";
}

void bounce() {
	int n, m;
	cin >> n >> m;
	ll** a = new ll*[n];
	for_(i, n) a[i] = new ll[m];
	for_(i, n) for_(j, m) cin >> a[i][j];
	int x, y, r;
	cin >> y >> x >> r;
	x--, y--;
	ll s = 0;
	while (a[y][x] != inf) {
		s += a[y][x];
		a[y][x] = inf;
		switch (r) {
		case 1:
			if (x == 0 && y == 0) {
				r = 7;
				y++;
			}
			else if (x == 0) {
				r = 5;
				x++;
			}
			else if (y == 0) {
				r = 4;
				x--;
			}
			else
				x--, y--;
			break;
		case 2:
			if (x == 0 && y == 0) {
				r = 8;
				x++, y++;
			}
			else if (y == 0) {
				r = 6;
				x--, y++;
			}
			else
				y--;
			break;
		case 3:
			if (x == m - 1 && y == 0) {
				r = 4;
				x--;
			}
			else if (x == m - 1) {
				r = 2;
				y--;
			}
			else if (y == 0) {
				r = 7;
				y++;
			}
			else
				x++, y--;
			break;
		case 4:
			if (x == 0 && y == n - 1) {
				r = 3;
				x++, y--;
			}
			else if (x == 0) {
				r = 8;
				x++, y++;
			}
			else
				x--;
			break;
		case 5:
			if (x == m - 1 && y == 0) {
				r = 6;
				x--, y++;
			}
			else if (x == m - 1) {
				r = 1;
				x--, y--;
			}
			else
				x++;
			break;
		case 6:
			if (x == 0 && y == n - 1) {
				r = 5;
				x++;
			}
			else if (x == 0) {
				r = 7;
				y++;
			}
			else if (y == n - 1) {
				r = 2;
				y--;
			}
			else
				x--, y++;
			break;
		case 7:
			if (x == m - 1 && y == n - 1) {
				r = 1;
				x--, y--;
			}
			else if (y == n - 1) {
				r = 3;
				x++, y--;
			}
			else
				y++;
			break;
		case 8:
			if (x == m - 1 && y == n - 1) {
				r = 2;
				y--;
			}
			else if (x == m - 1) {
				r = 4;
				x--;
			}
			else if (y == n - 1) {
				r = 5;
				x++;
			}
			else
				x++, y++;
			break;
		}
	}

	cout << s;
}

struct build {
	int r1, r2, r3, r4, t, d;
};

void clash_of_clans() {
	int x, y;
	cin >> x >> y;
	ll r1, r2, r3, r4;
	r1 = r2 = r3 = r4 = 30;
	set<ll> s[4];
	for_(i, 4) {
		s[i].insert(inf);
		for_(j, 5) {
			int t;
			cin >> t;
			if (t != 0)
				s[i].insert(t - 1);
		}
	}

	V<build> b;
	b.pb({ x, x, x, x, 9, 10});
	b.pb({ -y, -y, -y, -y, 0, 1 });

	for_(i, 100) {
		for (build& p : b) {
			if (p.t == i) {
				r1 += p.r1;
				r2 += p.r2;
				r3 += p.r3;
				r4 += p.r4;
				p.t += p.d;
			}
		}

		if (i == *s[0].begin() + 4) {
			b.pb({ 2, 0, 5, 0, i + 2, 2 });
			b.pb({ -3, 0, 0, 0, i + 5, 5 });
			s[0].erase(s[0].begin());
		}
		if (i == *s[0].begin()) {
			r1 -= 8;
			r2 -= 3;
			r3 -= 10;
		}

		if (i == *s[1].begin() + 4) {
			b.pb({ 0, 0, 0, 7, i + 5, 5 });
			b.pb({ 0, 0, -2, 0, i + 10, 10 });
			s[1].erase(s[1].begin());
		}
		if (i == *s[1].begin()) {
			r1 -= 5;
			r3 -= 8;
		}

		if (i == *s[2].begin() + 9) {
			b.pb({ 0, 6, 0, 0, i + 10, 10 });
			b.pb({ -2, 0, 0, 0, i + 18, 18 });
			s[2].erase(s[2].begin());
		}
		if (i == *s[2].begin()) {
			r1 -= 10;
			r2 -= 6;
			r3 -= 10;
		}

		if (i == *s[3].begin() + 7) {
			b.pb({ 0, 0, 8, 0, i + 8, 8 });
			b.pb({ -1, 0, -1, 0, i + 12, 12 });
			s[3].erase(s[3].begin());
		}
		if (i == *s[3].begin()) {
			r1 -= 8;
			r2 -= 4;
			r3 -= 8;
		}

		if (r1 <= 0 || r2 <= 0 || r3 <= 0 || r4 <= 0) {
			cout << i + 1 << endl << r1 << endl << r2 << endl << r3 << endl << r4;
			return;
		}
	}

	cout << 100 << endl << r1 << endl << r2 << endl << r3 << endl << r4;
}

struct metal {
	ii p1, p2;
	double r;
	bool sw = 0;
};

void optic() {
	int r, n;
	double u; // <- literally W
	cin >> r >> u >> n;
	double u0 = u / 10;
	metal* a = new metal[n];
	for_(i, n) {
		cin >> a[i].p1.F >> a[i].p1.S >> a[i].p2.F >> a[i].p2.S >> a[i].r;
		if (a[i].p1 > a[i].p2) {
			swap(a[i].p1, a[i].p2);
			a[i].sw = 1;
		}
	}
	int rx, ry;
	cin >> rx >> ry;

	int dx, dy;
	switch (r) {
	case 0:
		dx = 1;
		dy = 0;
		break;
	case 45:
		dx = 1;
		dy = 1;
		break;
	case 90:
		dx = 0;
		dy = 1;
		break;
	case 135:
		dx = -1;
		dy = 1;
		break;
	case 180:
		dx = -1;
		dy = 0;
		break;
	case 225:
		dx = -1;
		dy = -1;
		break;
	case 270:
		dx = 0;
		dy = -1;
		break;
	case 315:
		dx = 1;
		dy = -1;
		break;
	}

	int x = 0, y = 0, l;
	while (u >= u0) {
		ll bt = inf, b;
		for_(i, n) {
			if (a[i].p1.F == a[i].p2.F) {
				if (dx == 0)
					continue;
				int t = (a[i].p1.F - x) / dx;
				if (t <= 0 || y + dy * t < a[i].p1.S || y + dy * t > a[i].p2.S)
					continue;

				if (t < bt) {
					bt = t;
					b = i;
				}
			}
			else if (a[i].p1.S == a[i].p2.S) {
				if (dy == 0)
					continue;

				int t = (a[i].p1.S - y) / dy;
				if (t <= 0 || x + dx * t < a[i].p1.F || x + dx * t > a[i].p2.F)
					continue;

				if (t < bt) {
					bt = t;
					b = i;
				}
			}
			else if (a[i].p1.S < a[i].p2.S) {
				if (dx == dy)
					continue;
				int t = ((a[i].p1.F - a[i].p1.S) - (x - y)) / (dx - dy);
				if (t <= 0 || x + dx * t < a[i].p1.F || x + dx * t > a[i].p2.F)
					continue;

				if (t < bt) {
					bt = t;
					b = i;
				}
			}
			else {
				if (dx + dy == 0)
					continue;
				int t = ((a[i].p1.F + a[i].p1.S) - (x + y)) / (dx + dy);
				if (t <= 0 || x + dx * t < a[i].p1.F || x + dx * t > a[i].p2.F)
					continue;

				if (t < bt) {
					bt = t;
					b = i;
				}
			}
		}

		int rt = (rx - x) * dx;
		if (rt == (ry - y) * dy && rt >= 0 && rt <= bt) {
			cout << (int)u;
			return;
		}
		else {
			x += dx * bt;
			y += dy * bt;
			u *= (1 - a[b].r / 100.0);
			l = b;
			if (a[b].p1.F == a[b].p2.F)
				dx *= -1;
			else if (a[b].p1.S == a[b].p2.S)
				dy *= -1;
			else if (dx*dy != 0)
				dx *= -1, dy *= -1;
			else {
				swap(dx, dy);
				if(a[b].p1.S > a[b].p2.S)
					dx *= -1, dy *= -1;
			}
		}
	}

	if (a[l].sw)
		swap(a[l].p1, a[l].p2);
	cout << a[l].p1.F << ' ' << a[l].p1.S << ' ' << a[l].p2.F << ' ' << a[l].p2.S << ' ' << (int)u;
}

int main() {
	optic();
}