#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<cstdint>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<stack>
#include<queue>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<vector>
#include<string>
#include<random>
#include<stdio.h>
#include<numeric>
#include<bitset>
#include<cstring>

using namespace std;

#define ll long long
#define ld long double
#define all(x) begin(x), end(x)
#define int long long
// g++ -D_GLIBCXX_DEBUG -o main main.cpp

/*#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avhull[i].x,fma")*/
// #pragma GCC optimize("O3")

const long long MAXN = 3e5 + 500;
const long double PI = acosl(-1);
const int inf = 2e9;
const long long INF = 1e17;
const long long SZ = (1 << 19);
const int SIZE = 1e7 + 5;
const long long MOD = 1e9 + 7; // 998244353;
const long double eps = 1e-8;

std::random_device rd;
std::mt19937 ran(rd());

int getBit(int num, int nbit) {
    int mask = (1 << nbit);
    return (num & mask) ? 1 : 0;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto& i : arr) out << i << ' ';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (auto& i : arr) in >> i;
    return in;
}

set<pair<int, int>> f(pair<int, int> a) {
    set<pair<int, int>> st;
    for (int i = 0; i < 8; ++i) {
        if (a.first - i >= 0 && a.first - i < 8 && a.second - i >= 0 && a.second - i < 8)
            st.insert({ a.first - i, a.second - i });
    }
    for (int i = 0; i < 8; ++i) {
        if (a.first + i >= 0 && a.first + i < 8 && a.second - i >= 0 && a.second - i < 8)
            st.insert({ a.first + i, a.second - i });
    }
    for (int i = 0; i < 8; ++i) {
        if (a.first + i >= 0 && a.first + i < 8 && a.second + i >= 0 && a.second + i < 8)
            st.insert({ a.first + i, a.second + i });
    }
    for (int i = 0; i < 8; ++i) {
        if (a.first - i >= 0 && a.first - i < 8 && a.second + i >= 0 && a.second + i < 8)
            st.insert({ a.first - i, a.second + i });
    }
    return st;
}

void solve() {
    char ch; cin >> ch;
    pair<int, int> a, b, c;
    bool flag = false;
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            char x; cin >> x;
            if (ch == 'b') {
                if (x == 'B') {
                    a = { i, j };
                }
                if (x == 'w') {
                    if (!flag)
                        b = { i, j };
                    else
                        c = { i, j };
                    flag = true;
                }
            }
        }
    }
    set<pair<int, int>> A = f(a);
    int ind = 0;
    for (auto el : A) {
        //cout << el.first << ' ' << el.second << '\n';
        if (el.first == b.first && el.second == b.second) {
            ind = 1;
        } 
        if (el.first == c.first && el.second == c.second) {
            ind = 2;
        }
    }
    //cout << ind << '\n';
    set<pair<int, int>> P, t, st;
    if (ind == 1) {
        P = f(c);
        t = f(b);
    }
    else {
        P = f(b);
        t = f(c);
    }
    for (auto el : A) {
        for (auto it : t) {
            if (el.first == it.first && el.second == it.second) {
                st.insert(el);
            }
        }
    }
    /*for (auto el : st) {
        cout << el.first << ' ' << el.second << '\n';
    }*/
    pair<int, int> ans1 = { inf, inf }, ans2;
    for (auto el : st) {
        for (auto it : P) {
            if (el.first == it.first && el.second == it.second) {
                cout << el.first + 1 << ' ' << el.second + 1 << '\n';
                ans1 = el;
            }
        }
    }
    flag = false;
    for (int i = 0; i < 8; ++i) {
        if (flag) {
            cout << ans1.first - i + 1 << ' ' << ans1.second - i + 1 << '\n';
            return;
        }
        if (ans1.first - i >= 0 && ans1.first - i < 8 && ans1.second - i >= 0 && ans1.second - i < 8)
            if (ans1.first - i == c.first && ans1.second - i == c.first)
                flag = true;
    }
    for (int i = 0; i < 8; ++i) {
        if (flag) {
            cout << ans1.first + i + 1 << ' ' << ans1.second - i + 1 << '\n';
            return;
        }
        if (ans1.first + i >= 0 && ans1.first + i < 8 && ans1.second - i >= 0 && ans1.second - i < 8)
            if (ans1.first + i == c.first && ans1.second - i == c.first)
                flag = true;
    }
    for (int i = 0; i < 8; ++i) {
        if (flag) {
            cout << ans1.first + i + 1 << ' ' << ans1.second + i + 1 << '\n';
            return;
        }
        if (ans1.first + i >= 0 && ans1.first + i < 8 && ans1.second + i >= 0 && ans1.second + i < 8)
            if (ans1.first + i == c.first && ans1.second + i == c.first)
                flag = true;
    }
    for (int i = 0; i < 8; ++i) {
        if (flag) {
            cout << ans1.first - i + 1 << ' ' << ans1.second + i + 1 << '\n';
            return;
        }
        if (ans1.first - i >= 0 && ans1.first - i < 8 && ans1.second + i >= 0 && ans1.second + i < 8)
            if (ans1.first - i == c.first && ans1.second + i == c.first)
                flag = true;
    }
    return;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cout << fixed << setprecision(5);
#else
    ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(16);
#endif
    srand(time(NULL));
    //freopen("in.in", "r", stdin);
    //freopen("out.out", "w", stdout);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}