#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<cstdint>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<stack>
#include<queue>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<vector>
#include<string>
#include<random>
#include<stdio.h>
#include<numeric>
#include<bitset>
#include<cstring>

using namespace std;

#define ll long long
#define ld long double
#define all(x) begin(x), end(x)
#define int long long
// g++ -D_GLIBCXX_DEBUG -o main main.cpp

/*#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avhull[i].x,fma")*/
// #pragma GCC optimize("O3")

const long long MAXN = 3e5 + 500;
const long double PI = acosl(-1);
const int inf = 2e9;
const long long INF = 1e17;
const long long SZ = (1 << 19);
const int SIZE = 1e7 + 5;
const long long MOD = 1e9 + 7; // 998244353;
const long double eps = 1e-8;

std::random_device rd;
std::mt19937 ran(rd());

int getBit(int num, int nbit) {
    int mask = (1 << nbit);
    return (num & mask) ? 1 : 0;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto& i : arr) out << i << ' ';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (auto& i : arr) in >> i;
    return in;
}

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n); cin >> a >> b;
    vector<int> v;
    for (int i = 0; i < n; ++i) {
        if (a[i] > b[i]) {
            v.push_back(a[i] - b[i]);
        }
    }
    //cout << v << '\n';
    vector<int> dp(v.size(), 1);
    for (int i = 0; i < v.size(); ++i) {
        for (int j = 0; j < i; ++j) {
            if (v[i] > v[j])
                dp[i] = max(dp[i], dp[j] + 1);
        }
    }
    int mx = 0;
    for (int i = 0; i < v.size(); ++i) {
        mx = max(mx, dp[i]);
    }
    cout << mx << '\n';
    return;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cout << fixed << setprecision(5);
#else
    ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(16);
#endif
    srand(time(NULL));
    //freopen("in.in", "r", stdin);
    //freopen("out.out", "w", stdout);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}