#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<cstdint>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<stack>
#include<queue>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<vector>
#include<string>
#include<random>
#include<stdio.h>
#include<numeric>
#include<bitset>
#include<cstring>

using namespace std;

#define ll long long
#define ld long double
#define all(x) begin(x), end(x)
#define int long long
// g++ -D_GLIBCXX_DEBUG -o main main.cpp

/*#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avhull[i].x,fma")*/
// #pragma GCC optimize("O3")

const long long MAXN = 1e3 + 500;
const long double PI = acosl(-1);
const int inf = 2e9;
const long long INF = 1e17;
const long long SZ = (1 << 19);
const int SIZE = 1e7 + 5;
const long long MOD = 1e9 + 7; // 998244353;
const long double eps = 1e-6;

std::random_device rd;
std::mt19937 ran(rd());

int getBit(int num, int nbit) {
    int mask = (1 << nbit);
    return (num & mask) ? 1 : 0;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto& i : arr) out << i << ' ';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (auto& i : arr) in >> i;
    return in;
}

struct field {
    vector<vector<int>> f;
};

field a[20];
int n;

vector<vector<int>> rota(vector<vector<int>> v) {
    vector<vector<int>> res(4, vector<int>(4));
    int _i = 0, _j = 0;
    for (int j = 3; j >= 0; --j) {
        _j = 0;
        for (int i = 0; i < 4; ++i) {
            res[_i][_j] = v[i][j];
            _j++;
        }
        _i++;
    }
    return res;
}

void f(vector<vector<int>> field, vector<int> p, int ind) {
    if (ind == n) {
        bool ok = true;
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                if (field[i][j] != n) {
                    ok = false; break;
                }
            }
        }
        if (ok) {
            cout << p << '\n';
        }
        return;
    }
    vector<vector<int>> v = field;
    vector<vector<int>> tmp = a[p[ind]].f;
    int mx = -inf, mn = inf;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            v[i][j] += tmp[i][j];
        }
    }
    f(v, p, ind + 1);
    tmp = rota(tmp);
    v = field;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            v[i][j] += tmp[i][j];
        }
    }
    f(v, p, ind + 1);
    tmp = rota(tmp);
    v = field;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            v[i][j] += tmp[i][j];
        }
    }
    f(v, p, ind + 1);
    tmp = rota(tmp);
    v = field;
    mx = -inf; mn = inf;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            v[i][j] += tmp[i][j];
        }
    }
    f(v, p, ind + 1);
}

int was[50];

void solve() {
    cin >> n;
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < 4; ++i) {
            a[k].f.push_back({});
            for (int j = 0; j < 4; ++j) {
                int x; cin >> x;
                a[k].f[i].push_back(x);
            }
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = ran() % n + 1;
        while (was[ans[i]]) {
            ans[i] = ran() % n + 1;
        }
        was[ans[i]] = 1;
    }
    cout << ans << '\n';
    /*vector<vector<int>> v = rota(a[0].f);
    for (auto el : v) {
        cout << el << '\n';
    }*/
    return;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cout << fixed << setprecision(5);
#else
    ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(16);
#endif
    srand(time(NULL));
    //freopen("in.in", "r", stdin);
    //freopen("out.out", "w", stdout);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}