#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define FastIO() {ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);}
#define eol '\n'
#define ll long long

int main() {
    FastIO();
    ll n; cin >> n;
    vector <ll> a(n), b(n), c;
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < n; i++) {
        if (a[i] > b[i]) {
            c.push_back(a[i] - b[i]);
        }
    }
    ll sz = c.size();
    ll ans = 0;
    vector <ll> bestToTake(sz, 1);
    for (int i = sz-1; i >= 0; i--) {
        for (int j = i+1; j < sz; j++) {
            if (c[j] > c[i]) {
                bestToTake[i] = max(bestToTake[i], bestToTake[j] + 1);
            }
        }
        ans = max(ans, bestToTake[i]);
    }
    cout << ans << eol;
    return 0;
}