#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define FastIO() {ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);}
#define eol '\n'
#define ll long long

ll Rep = 40; // запчасти
ll Micro = 40; // микросхемы
ll Plactic = 40; // пластик
ll Food = 40; // еда
ll CurDay = 0; // текущий день

vector <int> ID1, ID2, ID3, ID4; // хранит номер дня старта
vector <pair<int, int>> built; // (ID, when start) 

int main() {
    // FastIO();
    ll X, Y; cin >> X >> Y;
    bool Alive = true;
    vector <vector<int>> Z(5, vector<int>(5));
    for (int i = 1; i < 5; i++){
        for (int j = 0; j < 5; j++) {
            cin >> Z[i][j];
        }
    }
    while (Alive && CurDay < 100) {
        CurDay += 1;
        if (CurDay % 10 == 0) { // поставки
            Rep += X;
            Micro += X;
            Plactic += X;
            Food += X;
        }
        for (int i = 0; i < (int)built.size(); i++) {
            if (built[i].second == CurDay) {
                if (built[i].first == 1) ID1.push_back(CurDay); 
                if (built[i].first == 2) ID2.push_back(CurDay); 
                if (built[i].first == 3) ID3.push_back(CurDay); 
                if (built[i].first == 4) ID4.push_back(CurDay); 
            }
        }
        // получение с заводов
        for (auto t: ID1) {
            if ((CurDay - t + 1) % 2 == 0) {
                Rep += 2; Plactic += 1;
            } 
            if ((CurDay - t + 1) % 5 == 0) {
                Rep -= 1;
            }
        }
        for (auto t: ID2) {
            if ((CurDay - t + 1) % 6 == 0) {
                Food += 8;
            } 
            if ((CurDay - t + 1) % 10 == 0) {
                Plactic -= 2;
            }
        }
        for (auto t: ID3) {
            if ((CurDay - t + 1) % 10 == 0) {
                Micro += 6;
            } 
            if ((CurDay - t + 1) % 20 == 0) {
                Rep -= 2;
            }
        }
        for (auto t: ID4) {
            if ((CurDay - t + 1) % 7 == 0) {
                Plactic += 7;
            } 
            if ((CurDay - t + 1) % 12 == 0) {
                Rep -= 1;
                Micro -= 1;
            }
        }
        // строительство заводов
        for (int j = 0; j < 5; j++) {
            if (Z[1][j] == CurDay) {
                built.push_back({1, CurDay + 6}); // CurDay + 6 - 1 закончит строительство
                Rep -= 5;
                Micro -= 5;
                Plactic -= 5;
            }
        }
        for (int j = 0; j < 5; j++) {
            if (Z[2][j] == CurDay) {
                built.push_back({2, CurDay + 4}); // CurDay + 6 - 1 закончит строительство
                Rep -= 5;
                Plactic -= 10;
            }
        }
        for (int j = 0; j < 5; j++) {
            if (Z[3][j] == CurDay) {
                built.push_back({3, CurDay + 10}); // CurDay + 6 - 1 закончит строительство
                Micro -= 5;
                Rep -= 10;
                Plactic -= 10;
            }
        }
        for (int j = 0; j < 5; j++) {
            if (Z[4][j] == CurDay) {
                built.push_back({4, CurDay + 8}); // CurDay + 6 - 1 закончит строительство
                Micro -= 5;
                Rep -= 10;
                Plactic -= 8;
            }
        }

        // потребление
        Rep -= Y;
        Micro -= Y;
        Plactic -= Y;
        Food -= Y;
        if (Rep <= 0 || Micro <= 0 || Plactic <= 0 || Food <= 0) {
            Alive = false;
            break;
        }
    }   
    cout << CurDay << eol;
    cout << Rep << eol;
    cout << Micro << eol;
    cout << Plactic << eol;
    cout << Food << eol; 
    return 0;
}