#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>

using namespace std;

#define FastIO() {ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);}
#define eol '\n'
#define ll long long

int n; 
int st, fn;
vector <int> a;
vector<vector<vector<int>>> blocks;

bool check() {
    vector <vector<int>> Map(40, vector<int>(4));
    bool Can = true;
    int sz = 0; int curI = 0;
    vector<vector<int>> block = blocks[st];
    int deep = 0;
    for (int i = 3; i >= 0; i--) {
        for (int j = 0; j < 4; j++) {
            if (block[i][j] == 0 && i <= 1) deep = max(deep, i + 1);
            if (Map[curI][j] == 1 && block[i][j] == 1) {
                Can = false;
                break;
            }
            Map[curI][j] = block[i][j];
        }
        if (!Can) break;
        curI++;
    }
    curI -= deep;
    sz += 4 - deep;
    if (!Can) return false;
    vector <int> curA = a; curA.push_back(fn + 1);
    for (int t = 0; t < (int)curA.size(); t++) {
        vector<vector<int>> block = blocks[curA[t] - 1];
        int deep = 0;
        for (int i = 3; i >= 0; i--) {
            for (int j = 0; j < 4; j++) {
                if (block[i][j] == 0 && i <= 1) deep = max(deep, i + 1);
                if (Map[curI][j] == 1 && block[i][j] == 1) {
                    Can = false;
                    break;
                }
                Map[curI][j] = max(Map[curI][j], block[i][j]);
            }
            if (!Can) break;
            curI++;
        }
        curI -= deep;
        sz += 4 - deep;
    }
    if (!Can) return false;
    // Проверка всего
    for (int i = 0; i < sz; i++) {
        for (int j = 0; j < 4; j++) {
            if (Map[i][j] == 0) {
                Can = false;
                break;
            }
        }
        if (!Can) break;
    }
    if (Can) return true;
    return false;
}

int main() {
    FastIO();
    cin >> n;
    if (n == 1) {
        cout << 1 << eol; 
        return 0;
    }
    blocks.resize(n, vector<vector<int>>(4, vector<int>(4)));
    for (int C = 0; C < n; C++) {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                cin >> blocks[C][i][j];
            }
        }
        bool allUp = true;
        for (int j = 0; j < 4; j++) {
            if (blocks[C][0][j] == 0) allUp = false;
        }

        bool allDown = true;
        for (int j = 0; j < 4; j++) {
            if (blocks[C][3][j] == 0) allDown = false;
        }
        if (allUp) {
            fn = C;
        } else if (allDown) {
            st = C;
        }
    }
    if (n == 2) {
        cout << st + 1 << " " << fn + 1 << eol;
        return 0;
    }
    a.resize(n-2);
    int last = 0;
    for (int i = 1; i <= n; i++) {
        if (i - 1 == st || i - 1 == fn) continue;
        a[last] = i;
        last++;
    }

    do {
        if (check()) {
            cout << st + 1 << " ";
            for (int i = 0; i < (int)a.size(); i++) {
                cout << a[i] << " ";
            }
            cout << fn + 1;
        }
    } while (next_permutation(a.begin(), a.end()));
    return 0;
}