#токарные изделия, электронные платы, бетон, еда

info = [{'cost': [8, 3, 10, 0], 'build-time': 5, 'earn': [2, 0, 5, 0], 'earn-delay': 2, 'ttt': [3, 0, 0, 0], 'ttt-delay': 5},
        {'cost': [5, 0, 8, 0], 'build-time': 5, 'earn': [0, 0, 0, 7], 'earn-delay': 5, 'ttt': [0, 0, 2, 0], 'ttt-delay': 10},
        {'cost': [10, 6, 10, 0], 'build-time': 10, 'earn': [0, 6, 0, 0], 'earn-delay': 10, 'ttt': [2, 0, 0, 0], 'ttt-delay': 18},
        {'cost': [8, 4, 8, 0], 'build-time': 8, 'earn': [0, 0, 8, 0], 'earn-delay': 8, 'ttt': [1, 1, 0, 0], 'ttt-delay': 12}]

class Plant:
    def __init__(self, ttype):
        self.delay = info[ttype]['build-time']
        self.delay2 = 0
        self.state = 'build'
        self.ttype = ttype
        #print(f'Начата постройка {ttype}')
    def update(self):
        self.delay -= 1
        self.delay2 -= 1
        if self.delay == 0 and self.state == 'build':
            #print(f'Завершена постройка {self.ttype}')
            self.state = 'production'
            self.delay = info[self.ttype]['earn-delay']
            self.delay2 = info[self.ttype]['ttt-delay']
            return [0, 0, 0, 0]
        res = [0, 0, 0, 0]
        if self.delay == 0 and self.state == 'production':
            #print(f'Получен доход с {self.ttype}')
            for i in range(4):
                res[i] += info[self.ttype]['earn'][i]
            self.delay = info[self.ttype]['earn-delay']
        if self.delay2 == 0 and self.state == 'production':
            #print(f'Расходы {self.ttype}')
            for i in range(4):
                res[i] -= info[self.ttype]['ttt'][i]
            self.delay2 = info[self.ttype]['ttt-delay']
        return res

X = int(input())
Y = int(input())

shedule = [[int(input()) for j in range(5)] for i in range(4)]

buildings = []

products = [30] * 4

month = 1

while month != 101 and all(p > 0 for p in products):
    #print(month, ':', *products)
    if month%10 == 0:
        for i in range(4):
            products[i] += X
    for i in range(4):
        for j in range(5):
            if shedule[i][j] == month:
                if all(products[k] >= info[i]['cost'][k] for k in range(4)):
                    for k in range(4):
                        products[k] -= info[i]['cost'][k]
                    buildings.append(Plant(i))
                break
    for plant in buildings:
        change = plant.update()
        for k in range(4):
            products[k] += change[k]
    for i in range(4):
        products[i] -= Y
    #print()
    month += 1

print(month-1)
print(*products)
