def GetMoves(i,j):
    moves = []
    directions = [(-1, -1),(+1, +1),(+1, -1),(-1, +1)]
    for di, dj in directions:
        startI, startJ = i + di, j + dj
        while 0 <= startI < 7 and 0 <= startJ < 7:
            moves.append((startI, startJ, (di, dj)))
            startI += di
            startJ += dj
    return moves


p = input()
matrix = []
for i in range(8):
    matrix.append(input().split())

posI = 0
posJ = 0
for i in range(8):
    for j in range(8):
        if matrix[i][j] == p.upper():
            posI = i
            posJ = j
            break

i = posI
j = posJ
for move in GetMoves(i, j):
    if matrix[move[0]][move[1]].lower() != p and matrix[move[0]][move[1]].lower() != "_":
        newI = move[0] + move[2][0]
        newJ = move[1] + move[2][1]
        while newI >=0 and newJ >= 0 and newI < 8 and newJ < 8:
            for newMove in GetMoves(newI, newJ):
                if matrix[newMove[0]][newMove[1]].lower() != p and matrix[newMove[0]][newMove[1]].lower() != "_" and move[:2] != newMove[:2]:
                    print(newI + 1, newJ + 1)
                    print(newMove[0]+newMove[2][0] + 1, newMove[1]+newMove[2][1] + 1)
                    exit(0)
            newI += move[2][0]
            newJ += move[2][1]






