import math

def intersect(rs, rangle, p1, p2):
    rad = math.radians(rangle)
    x0, y0 = rs
    x1, y1 = p1
    x2, y2 = p2
    dx = math.cos(rad)
    dy = math.sin(rad)
    ded = dx * (y2 - y1)- dy * (x2- x1)
    if ded == 0:
        return None
    t = ((x1 - x0)*(y2 - y1)-(y1 - y0)* (x2 - x1)) / ded
    s = ((x1 - x0)* dy - (y1 - y0) * dx) / ded
    if s <= 1 and s >= 0 and t >= 0:
        ix = x0 + t * dx
        iy = y0 + t * dy
        angle = math.degrees(math.atan2(y2 - y1,x2 - x1))
        return (ix,iy), 2 * angle -rangle
    return None


def dist(rs, rangle, point):
    rad = math.radians(rangle)
    x0, y0 = rs
    x, y = point
    dx = math.cos(rad)
    dy = math.sin(rad)
    scalar = (x - x0) * dx + (y - y0) * dy
    if scalar >= 0:
        return math.sqrt((x0+scalar*dx-x)** 2 + (y0+scalar*dy - y) ** 2)
    return None

angle, power = map(int,input().split())
n = int(input())
placts = []
for i in range(n):
    placts.append(list(map(int,input().split())))
endpoint = tuple(map(int,input().split()))
nowpoint = [0, 0]
minpower = 0.1 * power
Id_plact = -1
while True:
    respoint = ((math.inf,math.inf),0)
    for i in range(len(placts)):
        if i != Id_plact:
            res = intersect(nowpoint, angle, placts[i][:2], placts[i][2:4])
            if res != None:
                if math.dist(nowpoint,res[0]) < math.dist(nowpoint, respoint[0]):
                    respoint = res
                    Id_plact = i
    power *= 1 - placts[Id_plact][4] / 100
    nowpoint = respoint[0]
    angle = respoint[1]
    if power < minpower:
        print(*placts[Id_plact][:4], int(power))
        exit(0)
    d = dist(nowpoint,angle, endpoint)
    if d and d <= 0.5:
        print(int(power))
        exit(0)




