//#include <bits\stdc++.h>

#include <iostream>
#include <vector>
#include <cmath>
#include <stdint.h>
#include <set>

#define int long long
#define all(c) c.begin(), c.end()

using namespace std;

using ll = int64_t;
using ull = uint64_t;
//usinng ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;

const int INF = (int)1e9 + (int)1e3;
const int INFL = (int)1e18 + (int)1e6;
const int pi = atan2(0, -1);
const int M = (int)1e9 + 7;

int n, m;

int new_dir(int dir, int i, int j) {

    if (i == 0 && j == 0 && dir == 1) {
        return 8;
    } else if (i == 0 && j == m - 1 && dir == 3) {
        return 6;
    } else if (i == n - 1 && j == 0 && dir == 6) {
        return 3;
    } else if (i == n - 1 && j == m - 1 && dir == 8) {
        return 1;
    }

    if (i == 0) {
        if (dir == 3)
            return 8;
        else if (dir == 1)
            return 6;
        else if (dir == 2)
            return 7;
    } else if (i == n - 1) {
        if (dir == 7)
            return 2;
        else if (dir == 6)
            return 1;
        else if (dir == 8)
            return 3;
    } else if (j == 0) {
        if (dir == 6)
            return 8;
        else if (dir == 1)
            return 3;
        else if (dir == 4)
            return 5;
    } else if (j == m - 1) {
        if (dir == 8)
            return 6;
        else if (dir == 3)
            return 1;
        else if (dir == 5)
            return 4;
    }

    return dir;
}

void next(int dir, int& i, int& j) {
    if (dir < 4)
        i -= 1;
    else if (dir > 5)
        i += 1;

    if (dir == 1 || dir == 4 || dir == 6)
        j -= 1;
    else if (dir == 3 || dir == 5 || dir == 8)
        j += 1;
}

void solve() {
    //int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    int ci, cj;
    cin >> ci >> cj;
    --ci, --cj;

    int s = ci, f = cj;

    int sum = 0;
    int dir;
    cin >> dir;

	sum += a[ci][cj];
    a[ci][cj] = 0;

	set<pair<pii, int>> se;
	se.insert({ { s, f }, dir });

    dir = new_dir(dir, ci, cj);
    next(dir, ci, cj);
    while (!se.count({ { ci, cj}, dir })) {
        se.insert({ { ci, cj }, dir });
        sum += a[ci][cj];
        a[ci][cj] = 0;
        dir = new_dir(dir, ci, cj);
        next(dir, ci, cj);
    }

    cout << sum << "\n";
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}
