X = int(input())
Y = int(input())

resources = [30, 30, 30, 30]

# [токарное изделие, электроплата, бетон, еда]

factories = {
    0: {"price": [8, 3, 10, 0], "building_time": 5, "give_cd": 2, "give": [2, 0, 5, 0], "require": [3, 0, 0, 0], "require_cd": 5},
    1: {"price": [5, 0, 8, 0], "building_time": 5, "give_cd": 5, "give": [0, 0, 0, 7], "require": [0, 0, 2, 0], "require_cd": 10},
    2: {"price": [10, 6, 10, 0], "building_time": 10, "give_cd": 10, "give": [0, 6, 0, 0], "require": [2, 0, 0, 0], "require_cd": 18},
    3: {"price": [8, 4, 8, 0], "building_time": 8, "give_cd": 8, "give": [0, 0, 8, 0], "require": [1, 1, 0, 0], "require_cd": 12}
}

building_factories = []
for i in range(4):
    x = []
    for j in range(5):
        x.append(int(input()))
    x.append(999999)
    building_factories.append(x)

last_month = 1

active_factories = []

cur_building = [0, 0, 0, 0]

def check_resources(need):
    global resources
    for i in range(4):
        if need[i] == 0: continue
        if resources[i] < need[i]: return False

    return True

def add_resources(to_add):
    global resources
    for i in range(4):
        resources[i] += to_add[i]

def take_resources(to_take):
    global resources
    for i in range(4):
        resources[i] -= to_take[i]

work = True

for month in range(1, 101):
    if any([x <= 0 for x in resources]):
        break
    if (month % 10 == 0):
        resources = [x + X for x in resources]

    for i in range(4):
        if building_factories[i][cur_building[i]] == month:
            kek = True
            # if cur_building[i] > 0:
            #     delta = building_factories[i][cur_building[i]] - building_factories[i][cur_building[i] - 1]
            #     print("delta", delta)
            #     if delta < factories[i]["building_time"]:
            #         kek = False
            if check_resources(factories[i]["price"]) and kek:
                info = {"id": i,
                        "built": month,
                        "nxt_give": month + factories[i]["building_time"] + factories[i]["give_cd"] - 1,
                        "nxt_require": month + factories[i]["building_time"] + factories[i]["require_cd"] - 1}
                active_factories.append(info)
                take_resources(factories[i]["price"])
                cur_building[i] += 1
            else:
                building_factories[i][cur_building[i]] += 1


    for factory in active_factories:
        if factory["nxt_give"] == month:
            add_resources(factories[factory["id"]]["give"])
            factory["nxt_give"] += factories[factory["id"]]["give_cd"]
        
        if factory["nxt_require"] == month:
            take_resources(factories[factory["id"]]["require"])
            factory["nxt_require"] += factories[factory["id"]]["require_cd"]


    resources = [x - Y for x in resources]

    last_month = month

print(last_month)
print(*resources, sep="\n")