angle, start_intensity = map(int, input().split())

intensity = start_intensity

n = int(input())

rect = []
for _ in range(n):
    data = input().split()
    x1, y1, x2, y2 = map(int, data[:4])
    perc = float(data[4])
    rect.append([x1, y1, x2, y2, perc])

x, y = 0, 0
X, Y = map(int, input().split())

def get_speed(angle):
    angle = angle % 360
    if angle == 0:
        return 1, 0
    if angle == 45:
        return 1, 1
    if angle == 90:
        return 0, 1
    if angle == 135:
        return -1, 1
    if angle == 180:
        return -1, 0
    if angle == 225:
        return -1, -1
    if angle == 270:
        return 0, -1
    if angle == 315:
        return 1, -1
    
def check(a, b, rect):
    x1, y1, x2, y2 = rect[:4]
    return x1 <= a <= x2 and y2 <= b <= y1

def collision_id(a, b, rect):
    x1, y1, x2, y2 = rect[:4]
    if b in [y1, y2]:
        return 1
    if a in [x1, x2]:
        return 2
    return 0

speed = list(get_speed(angle))

work = True

while work:
    x = x + speed[0]
    y = y + speed[1]
    if x == X and y == Y:
        print(int(intensity))
        break
    for i in rect:
        collision = check(x, y, i)
        cid = collision_id(x, y, i)
        if not collision: continue
        if cid == 1:
            speed[1] = -speed[1]
        elif cid == 2:
            speed[0] = -speed[0]
        intensity = intensity * (100 - i[4]) / 100
        if intensity < start_intensity * 0.1:
            work = False
            print(*i[:4], int(intensity))
        break
    if abs(x) > 10 or abs(y) > 10:
        break