#include <bits/stdc++.h>

using namespace std;
using pint = pair<int, int>;

struct Dec {
    int x1, y1, x2, y2, id;
    char cls;

    double vr;

    char intersect(int x, int y) {
        if (cls == 'V') {
            if (x != x1) return 'N';

            if (y <= y2 || y >= y1) return 'N';
            return 'V';
        } else {
            if (y != y1) return 'N';

            if (x <= x1 || x >= x2) return 'N';
            return 'H';
        }
    }
};

void solve() {
    int deg;
    double intense;
    cin >> deg >> intense;

    double initial = intense;

    int n;
    cin >> n;

    vector<vector<int>> p(n, vector<int>(4));
    vector<Dec> d(4 * n);
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;

        double vr;
        cin >> vr;

        vr = (100 - vr) / 100.0;

        d[4 * i] = {x1, y1, x1, y2, i, 'V', vr};
        d[4 * i + 1] = {x1, y1, x2, y1, i, 'H', vr};
        d[4 * i + 2] = {x2, y1, x2, y2, i, 'V', vr};
        d[4 * i + 3] = {x1, y2, x2, y2, i, 'H', vr};

        p[i] = {x1, y1, x2, y2};
    }

    int xr, yr;
    cin >> xr >> yr;

    int x = 0, y = 0;
    while (true) {
        if (x == xr && y == yr) {
            cout << int(intense) << "\n";
            return;
        }

        for (int i = 0; i < 4 * n; ++i) {
            auto cur = d[i];

            char res = cur.intersect(x, y);
            if (res == 'N') continue;

            if (res == 'V') {
                if (deg == 0) {
                    deg = 180;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 45) {
                    deg = 135;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 90) {
                    deg = 270;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 135) {
                    deg = 45;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 180) {
                    deg = 0;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 225) {
                    deg = 315;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 270) {
                    deg = 90;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 315) {
                    deg = 225;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }
            } else {
                if (deg == 0) {
                    deg = 180;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 45) {
                    deg = 315;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 90) {
                    deg = 270;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 135) {
                    deg = 225;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 180) {
                    deg = 0;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 225) {
                    deg = 135;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 270) {
                    deg = 90;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }

                if (deg == 315) {
                    deg = 45;

                    intense *= cur.vr;

                    if (intense <= 0.1 * initial) {
                        int id = cur.id;
                        for (auto &item : p[id]) cout << item << " ";
                        cout << int(intense);

                        return;
                    }

                    break;
                }
            }
        }

        if (deg == 0) {
            ++x;
        }

        if (deg == 45) {
            ++x, ++y;
        }

        if (deg == 90) {
            ++y;
        }

        if (deg == 135) {
            --x, ++y;
        }

        if (deg == 180) {
            --x;
        }

        if (deg == 225) {
            --x, --y;
        }

        if (deg == 270) {
            --y;
        }

        if (deg == 315) {
            ++x, --y;
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}
