#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define size(a) (int)a.size()
#define int long long

using namespace std;
using ll = long long;
using ld = long double;
using pi = pair<int, int>;

template<typename T = int> T scn() {T x; cin >> x; return x; }
template<typename T> bool ckmin(T &a, const T &b) {return b < a && (a = b, true); }
template<typename T> bool ckmax(T &a, const T &b) {return b > a && (a = b, true); }
template<typename T> bool ckpass(T &a, const T &b, bool con) {return con && (a = b, true); }
template<typename T> bool ckpass(T &a, const T &b, const T &c, bool con) {return con ? (a = b, true) : (a = c, false); }

int t[5] = {0, 6, 4, 10, 8};
int w[5] = {0, 2, 6, 10, 7};
int d[5] = {0, 5, 10, 20, 12};
array<int, 4> r = {};
array<int, 4> cost[5] = {
        {0, 0, 0, 0},
        {5, 5, 5, 0},
        {5, 0, 10, 0},
        {10, 5, 10, 0},
        {1, 1, 0, 0}
};

array<int, 4> add[5] = {
        {0, 0, 0, 0},
        {2, 0, 1, 0},
        {0, 0, 0, 8},
        {0, 6, 0, 0},
        {0, 0, 7, 0}
};

array<int, 4> dif[5] = {
        {0, 0, 0, 0},
        {1, 0, 0, 0},
        {0, 0, 2, 0},
        {2, 0, 0, 0},
        {1, 1, 0, 0}
};



void operator+=(array<int, 4> &a, array<int, 4> b) {
    for (int i = 0; i < 4; ++i) {
        a[i] += b[i];
    }
}
void operator-=(array<int, 4> &a, array<int, 4> b) {
    for (int i = 0; i < 4; ++i) {
        a[i] -= b[i];
    }
}

void solution() {
    int x = scn(), y = scn();
    fill(all(r), 40);
    queue<pi> plan[5] = {};
    deque<pi> build = {};
    vector<pi> earn[5] = {};
    vector<pi> waste[5] = {};
    int cnt = 0;
    for (int id = 1; id <= 4; ++id) {
        for (int j = 0; j < 5; ++j) {
            int c = scn();
            if (c != 0) plan[id].push({c, t[id]});
        }
    }
    for (int T = 1; T <= 100; ++T) {
        if (T % 10 == 0) r += {x, x, x, x};
        for (int id = 1; id <= 4; ++id) {
            if (plan[id].empty()) continue;
            if (plan[id].front().first == T) {
                build.push_back({t[id], id});
                r -= cost[id];
                plan[id].pop();
            }
        }

        for (auto &i : build) {
            i.first--;
        }

        for (auto &i : build) {
            if (i.first == 0) {
                earn[i.second].push_back({w[i.second], i.second});
                waste[i.second].push_back({d[i.second], i.second});
                cnt++;
            }
        }

        for (int id = 1; id <= 4; ++id) {
            for (auto &i : earn[id]) {
                if (i.first == 0) {
                    r += add[id];
                    i.first = w[id];
                } else {
                    i.first--;
                }
            }
            for (auto &i : waste[id]) {
                if (i.first == 0) {
                    r -= dif[id];
                    i.first = d[id];
                } else {
                    i.first--;
                }
            }
        }
        if (cnt == 0) {
            for (int j = 0; j < 4; ++j) {
                r[j] -= y;
            }
        }
        for (int j = 0; j < 4; ++j) {
            if (r[j] <= 0) {
                cout << T << '\n';
                for (int k : r) {
                    cout << k << '\n';
                }
                return;
            }
        }
    }
    cout << 100 << '\n';

    for (int k : r) {
        cout << k << '\n';
    }
}

signed main() {
    #ifdef ONPC
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
    #endif
    solution();
}

