#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define size(a) (int)a.size()
#define int long long
#define clr(a) memset(a, 0, sizeof a)

using namespace std;
using ll = long long;
using ld = long double;
using pi = pair<int, int>;

template<typename T = int> T scn() {T x; cin >> x; return x; }
template<typename T> bool ckmin(T &a, const T &b) {return b < a && (a = b, true); }
template<typename T> bool ckmax(T &a, const T &b) {return b > a && (a = b, true); }
template<typename T> bool ckpass(T &a, const T &b, bool con) {return con && (a = b, true); }
template<typename T> bool ckpass(T &a, const T &b, const T &c, bool con) {return con ? (a = b, true) : (a = c, false); }
bitset<3> wall = 7;
struct unit {
    bitset<3> bot = 0, top = 0;
    unit reverse() {
        unit res;
        res.bot[0] = top[2];
        res.bot[1] = top[1];
        res.bot[2] = top[0];

        res.top[0] = bot[2];
        res.top[1] = bot[1];
        res.top[2] = bot[0];
        return res;
    }

    bool placed_on(unit oth) {
        return (bot ^ oth.top) == wall;
    }
};

int fact[11];

void solution() {
    int n = scn();
    if (n == 1) {
        cout << 1 << '\n';
        return;
    }
    if (n == 2) {
        cout << "1 2\n";
        return;
    }
    vector<unit> units;
    int st = -1, fn = -1;
    unit S, F;
    for (int i = 0; i < n; ++i) {
        unit cur;
        for (int j = 0; j < 3; ++j) {
            int b = scn();
            if (b) cur.top |= (1 << j);
        }
        scn(), scn(), scn();
        for (int j = 0; j < 3; ++j) {
            int b = scn();
            if (b) cur.bot |= (1 << j);
        }
        if (cur.bot == wall || cur.top == wall) {
            if (st == -1) st = i, S = cur;
            else fn = i, F = cur;
        }
        units.push_back(cur);
    }
    vector<int> p = {st};
    for (int i = 0; i < n; ++i) {
        if (i != st && i != fn) p.push_back(i);
    }
    p.push_back(fn);
    for (int _ = 0; _ < fact[n - 2]; ++_) {
        int dp[n][2]; clr(dp);
        dp[0][0] |= S.bot == wall;
        dp[0][1] |= S.reverse().bot == wall;
        for (int i = 1; i < n; ++i) {
            dp[i][0] |= units[p[i]].placed_on(units[p[i - 1]]) && dp[i - 1][0];
            dp[i][0] |= units[p[i]].placed_on(units[p[i - 1]].reverse()) && dp[i - 1][1];
            dp[i][1] |= units[p[i]].reverse().placed_on(units[p[i - 1]]) && dp[i - 1][0];
            dp[i][1] |= units[p[i]].reverse().placed_on(units[p[i - 1]].reverse()) && dp[i - 1][1];
        }
        if (dp[n - 1][0] || dp[n - 1][1]) {
            for (int i : p) {
                cout << i + 1 << ' ';
            } cout << '\n';
            return;
        }
        next_permutation(1 + all(p) - 1);
    }
}

signed main() {
    #ifdef ONPC
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
    #endif
    fact[0] = fact[1] = 1;
    for (int i = 2; i <= 10; ++i) fact[i] = fact[i - 1] * i;
    solution();
}
