def mres(res, val):
    return tuple(res[i]+val[i] for i in range(4))

def main():
    x, y = int(input()), int(input())
    build_plan = tuple(tuple(int(input()) for i in range(5)) for j in range(4))

    ## Dt, msh, pl, fd
    build = {
        1: {
            "price": (-5, -5, -5, 0),
            "build_time": 6,
            "out": (2, (2, 0, 1, 0)),
            "in": (5, (-1, 0, 0, 0))
        },
        2: {
            "price": (-5, 0, -10, 0),
            "build_time": 4,
            "out": (6, (0, 0, 0, 8)),
            "in": (10, (0, 0, -2, 0))
        },
        3: {
            "price": (-10, -5, -10, 0),
            "build_time": 10,
            "out": (10, (0, 6, 0, 0)),
            "in": (20, (-2, 0, 0, 0))
        },
        4: {
            "price": (-10, -5, -8, 0),
            "build_time": 8,
            "out": (7, (0, 0, 7, 0)),
            "in": (12, (-1, -1, 0, 0))
        }
    }
    builds = {
        "in_build": [],
        "ready": []
    }
    resources = [40 for i in range(4)]

    for b in range(4):
        if 1 in build_plan[b]:
            cur = build[b+1]
            builds["in_build"].append([b+1, cur["build_time"]])
            resources = mres(resources, cur["price"])

    for day in range(1, 101):
        if day%10 == 0:
            resources = mres(resources, [x for _ in range(4)])
            
            for b in range(4):
                if day in build_plan[b]:
                    cur = build[b+1]
                    builds["in_build"].append([b+1, cur["build_time"]])
                    resources = mres(resources, cur["price"])
            
        ready = []
        for b in builds["in_build"]:
            if b[1] == 0:
                cur = build[b[0]]
                builds["ready"].append([
                    list(range(day-1, 101, cur["in"][0])),
                    cur["in"][1],
                    list(range(day-1, 101, cur["out"][0])),
                    cur["out"][1]
                ])
                ready.append(builds["in_build"].index(b))
            else: b[1] -= 1
        for b in ready: builds["in_build"].pop(b)

        for b in builds["ready"]:
            if day in b[0]:
                resources = mres(resources, b[1])
            if day in b[2]:
                resources = mres(resources, b[3])

        resources = mres(resources, [-1*y for _ in range(4)])
        for i in resources:
            if i <= 0:
                return (day, resources)
    return (100, resources)

    
if __name__ == "__main__":
    res = main()
    print(res[0])
    for i in res[1]:
        print(i)
