def move(pos, delta):
    return (pos[0]+delta[0], pos[1]+delta[1])

def main():
    start_angle, start_force = map(int, input().split())
    n = int(input())
    boxes = tuple(tuple(map(int, input().split())) for _ in range(n))
    target = tuple(map(int, input().split()))

    angles = {
        0:   (1, 0),
        45:  (1, 1),
        90:  (0, 1),
        135: (-1, 1),
        180: (-1, 0),
        225: (-1, -1),
        270: (0, -1),
        315: (1, -1)
    }
    angle, force = angles[start_angle], start_force
    cur_pos = (0, 0)

    last_box = ()
    while force/start_force >= .1 and cur_pos != target:
        #print(cur_pos)
        for box in boxes:
            if cur_pos[0] in (box[0], box[2]) and cur_pos[1] in range(box[3], box[1]+1):
                #print("boom")
                angle = (-1*angle[0], angle[1])
                force *= (100-box[4])/100
                last_box = box
                break
            if cur_pos[1] in (box[3], box[1]) and cur_pos[0] in range(box[0], box[2]+1):
                #print("boom")
                angle = (angle[0], -1*angle[1])
                force *= (100-box[4])/100
                last_box = box
                break
        cur_pos = move(cur_pos, angle)

    if force/start_force < .1:
        return (False, force, last_box[:4])
    return (True, force)

if __name__ == "__main__":
    res = main()
    if res[0]:
        print(int(res[1]))
    else:
        for i in res[2]: print(i, end=" ")
        print(int(res[1]))
