n = int(input())

puzzles = []

def puzRev(puzzle):
    newPuzzle =  []
    for i in range(2, -1, -1):
        newPuzzle.append(puzzle[i].copy()[::-1])
    return newPuzzle

def check(down, up):
    for i in range(3):
        if down[0][i] == up[-1][i]:
            return False
    return True

def checkRev(down, up):
    upRev = puzRev(up)
    for i in range(3):
        if down[0][i] == upRev[-1][i]:
            return False
    return True

def dfs(puzzle, path):
    if len(path) == n:
        ans = []
        for el in path:
            ans.append(el+1)
        print(*ans)

    for i in range(len(puzzles)):
        if i not in path:
            if check(puzzle, puzzles[i]):
                dfs(puzzles[i], path + [i])
            elif checkRev(puzzle, puzzles[i]):
                bufPuzzle = puzRev(puzzles[i])
                dfs(bufPuzzle, path + [i])



for i in range(n):
    puz = [input().split() for j in range(3)]
    puzzles.append(puz)

start = n

for i in range(len(puzzles)):
    if puzzles[i][0] == ['1', '1', '1'] or puzzles[i][-1] == ['1', '1', '1']:
        start = i
        break

if puzzles[start][0] == ['1', '1', '1']:
    puzzles[start] = puzRev(puzzles[start])

dfs(puzzles[start], [start])