n, m = map(int, input().split())
a = [list(map(int, input().split())) for _ in range(n)]
x, y = map(int, input().split())

# Account for input indexes starting from 1
x -= 1
y -= 1

d = (
    [-1, -1],  # 1
    [-1, 0],   # 2
    [-1, 1],   # 3
    [0, -1],   # 4
    [0, 1],    # 5
    [1, -1],   # 6
    [1, 0],    # 7
    [1, 1]     # 8
)[int(input()) - 1]

# Reference:
# [-1, -1]: [-1, 0],  # 1 -> 2
# [-1, 0]: [-1, 1],   # 2 -> 3
# [-1, 1]: [0, 1],    # 3 -> 5
# [0, 1]: [1, 1],     # 5 -> 8
# [1, 1]: [1, 0],     # 8 -> 7
# [1, 0]: [1, -1],    # 7 -> 6
# [1, -1]: [0, -1],   # 6 -> 4
# [0, -1]: [-1, -1]   # 4 -> 1
d_rot = {
    0: {
        1: [1, 1],
        -1: [-1, -1]
    },
    1: {
        0: [1, -1],
        1: [1, 0],
        -1: [0, -1]
    },
    -1: {
        0: [-1, 1],
        1: [0, 1],
        -1: [-1, 0]
    }
}

score = 0
while a[x][y] != -10001:
    # IF WE ARE AT AN EDGE, ROTATE
    f = False
    if ((x + d[0]) == n) or ((x + d[0]) == -1):
        d[0] *= -1
        f = True
    if ((y + d[1]) == m) or ((y + d[1]) == -1):
        d[1] *= -1
        f = True
    if f:
        d = d_rot[d[0]][d[1]].copy()  # ! This copy is **very** important

    score += a[x][y]
    a[x][y] = -10001
    x += d[0]
    y += d[1]

print(score)
