# Check if 2 blocks fit together
def fits(x, y):
    yt = y.replace('1', '2').replace('0', '1').replace('2', '0')
    return x == yt or x == yt[::-1]


n = int(input())
a = []
for i in range(n):
    top = input().replace(' ', '')
    input()  # Discard middle piece since it's useless
    bottom = input().replace(' ', '')
    a.append((top, bottom))


def traverse(cur: str, pool: list, ind: list, hunted):
    pool.remove(hunted)
    ind.append(hunted)

    # All blocks were used, therefore tower is complete
    if not pool:
        output = ''
        for out in ind:
            output += str(a.index(out) + 1) + ' '
        print(output)
        exit()

    for el in range(len(pool)):
        if fits(cur, pool[el][1]):
            traverse(pool[el][0], pool.copy(), ind.copy(), pool[el])
        if fits(cur, pool[el][0]):
            traverse(pool[el][1], pool.copy(), ind.copy(), pool[el])


# We only need to check first possible path
# Since we are guaranteed to have 1 correct, with minimal starting element
for i in range(n):
    if a[i][0] == '111':
        traverse(a[i][1], a.copy(), [], a[i])
        break
    elif a[i][1] == '111':
        traverse(a[i][0], a.copy(), [], a[i])
        break
