﻿#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<algorithm>

#define ll long long
#define ii pair<ll, ll>
#define V vector
#define F first
#define S second
#define P pair
#define pb push_back
#define for_(i, n) for(int i = 0; i < n; i++)
#define for_in(i, l, r) for(int i = l; i < r; i++)
#define for_r(i, n) for(int i = n - 1; i >= 0; i--)
#define has(s, x) (s.find(x) != s.end())

using namespace std;

const ll inf = 1ll << 60;

void eco() {
	ll s, r, d;
	cin >> s >> r >> d;

	for_(i, 50) {
		s += s * r / 100;
		for_(j, 12) {
			s -= d;

			if (s <= 0) {
				cout << "True\n" << i * 12 + j;
				return;
			}
		}
	}
	cout << "False\n0";
}

void bounce() {
	int n, m;
	cin >> n >> m;
	ll** a = new ll*[n];
	for_(i, n) a[i] = new ll[m];
	for_(i, n) for_(j, m) cin >> a[i][j];
	int x, y, r;
	cin >> y >> x >> r;
	x--, y--;
	ll s = 0;
	while (a[y][x] != inf) {
		s += a[y][x];
		a[y][x] = inf;
		switch (r) {
		case 1:
			if (x == 0 && y == 0) {
				r = 7;
				y++;
			}
			else if (x == 0) {
				r = 5;
				x++;
			}
			else if (y == 0) {
				r = 4;
				x--;
			}
			else
				x--, y--;
			break;
		case 2:
			if (x == 0 && y == 0) {
				r = 8;
				x++, y++;
			}
			else if (y == 0) {
				r = 6;
				x--, y++;
			}
			else
				y--;
			break;
		case 3:
			if (x == m - 1 && y == 0) {
				r = 4;
				x--;
			}
			else if (x == m - 1) {
				r = 2;
				y--;
			}
			else if (y == 0) {
				r = 7;
				y++;
			}
			else
				x++, y--;
			break;
		case 4:
			if (x == 0 && y == n - 1) {
				r = 3;
				x++, y--;
			}
			else if (x == 0) {
				r = 8;
				x++, y++;
			}
			else
				x--;
			break;
		case 5:
			if (x == m - 1 && y == 0) {
				r = 6;
				x--, y++;
			}
			else if (x == m - 1) {
				r = 1;
				x--, y--;
			}
			else
				x++;
			break;
		case 6:
			if (x == 0 && y == n - 1) {
				r = 5;
				x++;
			}
			else if (x == 0) {
				r = 7;
				y++;
			}
			else if (y == n - 1) {
				r = 2;
				y--;
			}
			else
				x--, y++;
			break;
		case 7:
			if (x == m - 1 && y == n - 1) {
				r = 1;
				x--, y--;
			}
			else if (y == n - 1) {
				r = 3;
				x++, y--;
			}
			else
				y++;
			break;
		case 8:
			if (x == m - 1 && y == n - 1) {
				r = 2;
				y--;
			}
			else if (x == m - 1) {
				r = 4;
				x--;
			}
			else if (y == n - 1) {
				r = 5;
				x++;
			}
			else
				x++, y++;
			break;
		}
	}

	cout << s;
}

int main() {
	bounce();
}